# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rail_ceiling/Obstacles.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rail_ceiling.msg

class Obstacles(genpy.Message):
  _md5sum = "1c9abad7770de5c037ab52aab3bbc997"
  _type = "rail_ceiling/Obstacles"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """rail_ceiling/Obstacle[] localizationObstacles #list of obstacles for the localization map layer
rail_ceiling/Obstacle[] navigationObstacles   #list of obstacles for the navigation map layer
================================================================================
MSG: rail_ceiling/Obstacle
int32 id                       	  #obstacle id
geometry_msgs/Polygon[] polygons  #list of polygons defining the obstacle

================================================================================
MSG: geometry_msgs/Polygon
#A specification of a polygon where the first and last points are assumed to be connected
Point32[] points

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z"""
  __slots__ = ['localizationObstacles','navigationObstacles']
  _slot_types = ['rail_ceiling/Obstacle[]','rail_ceiling/Obstacle[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       localizationObstacles,navigationObstacles

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Obstacles, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.localizationObstacles is None:
        self.localizationObstacles = []
      if self.navigationObstacles is None:
        self.navigationObstacles = []
    else:
      self.localizationObstacles = []
      self.navigationObstacles = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.localizationObstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.localizationObstacles:
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.polygons)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygons:
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.navigationObstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.navigationObstacles:
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.polygons)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygons:
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.localizationObstacles is None:
        self.localizationObstacles = None
      if self.navigationObstacles is None:
        self.navigationObstacles = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.localizationObstacles = []
      for i in range(0, length):
        val1 = rail_ceiling.msg.Obstacle()
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygons = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Polygon()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point32()
            _x = val3
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            val2.points.append(val3)
          val1.polygons.append(val2)
        self.localizationObstacles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.navigationObstacles = []
      for i in range(0, length):
        val1 = rail_ceiling.msg.Obstacle()
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygons = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Polygon()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point32()
            _x = val3
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            val2.points.append(val3)
          val1.polygons.append(val2)
        self.navigationObstacles.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.localizationObstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.localizationObstacles:
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.polygons)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygons:
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.navigationObstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.navigationObstacles:
        buff.write(_struct_i.pack(val1.id))
        length = len(val1.polygons)
        buff.write(_struct_I.pack(length))
        for val2 in val1.polygons:
          length = len(val2.points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.points:
            _x = val3
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.localizationObstacles is None:
        self.localizationObstacles = None
      if self.navigationObstacles is None:
        self.navigationObstacles = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.localizationObstacles = []
      for i in range(0, length):
        val1 = rail_ceiling.msg.Obstacle()
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygons = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Polygon()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point32()
            _x = val3
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            val2.points.append(val3)
          val1.polygons.append(val2)
        self.localizationObstacles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.navigationObstacles = []
      for i in range(0, length):
        val1 = rail_ceiling.msg.Obstacle()
        start = end
        end += 4
        (val1.id,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.polygons = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Polygon()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point32()
            _x = val3
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            val2.points.append(val3)
          val1.polygons.append(val2)
        self.navigationObstacles.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_i = struct.Struct("<i")
_struct_3f = struct.Struct("<3f")
